summaryrefslogtreecommitdiffstats
path: root/development/arduino/arduino.SlackBuild
diff options
context:
space:
mode:
Diffstat (limited to 'development/arduino/arduino.SlackBuild')
-rw-r--r--development/arduino/arduino.SlackBuild66
1 files changed, 57 insertions, 9 deletions
diff --git a/development/arduino/arduino.SlackBuild b/development/arduino/arduino.SlackBuild
index 925a5a34cc..abf5409d76 100644
--- a/development/arduino/arduino.SlackBuild
+++ b/development/arduino/arduino.SlackBuild
@@ -1,37 +1,85 @@
#!/bin/sh
# Slackware build script for Arduino IDE
-# Written by Diogo Leal(estranho)
+
+# Written by Diogo Leal(estranho) untill 0019.
+# Rewritten from scratch by Vliegendehuiskat since 0022.
+# E-mail: vliegendehuiskat [at] gmail [dot] com.
+
+# The Java part of the Arduino IDE licensed under GPL.
+# The C/C++ microcontroller library files are licensed under LGPL.
+
+# This script is released in the public domain.
+# I am not responsible for any consequences that follow from the
+# incorrect use of this script.
PRGNAM=arduino
-VERSION=${VERSION:-0019}
+VERSION=${VERSION:-0022}
BUILD=${BUILD:-1}
TAG=${TAG:-_SBo}
-CWD=$(pwd)
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
TMP=${TMP:-/tmp/SBo}
PKG=$TMP/package-$PRGNAM
OUTPUT=${OUTPUT:-/tmp}
-ARCH=i486
+if [ "$ARCH" = "i486" ]; then
+ LIBDIRSUFFIX=""
+ SRCSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ LIBDIRSUFFIX=""
+ SRCSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ LIBDIRSUFFIX="64"
+ SRCSUFFIX="-64-2"
+else
+ echo "$ARCH architecture not supported"
+ exit 1
+fi
+
+SYSTEMFOLDER=${SYSTEMFOLDER:-/opt/$PRGNAM}
+SOURCENAME=$PRGNAM-$VERSION$SRCSUFFIX.tgz
set -e
rm -rf $PKG
-mkdir -p $TMP $PKG $OUTPUT
+mkdir -p $TMP $PKG $OUTPUT
rm -rf $TMP/$PRGNAM-$VERSION
cd $TMP
-tar xvf $CWD/$PRGNAM-$VERSION.tgz
+tar xvf $CWD/$SOURCENAME
cd $PKG
-chown -R root:root .
+chown -R root:root $PKG $TMP/$PRGNAM-$VERSION
find . \
\( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
-exec chmod 755 {} \; -o \
\( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
-exec chmod 644 {} \;
-mkdir -p $PKG/opt
-cp -a ../$PRGNAM-$VERSION $PKG/opt/arduino
+# Add a wrapper to run the arduino ide from /usr/bin
+# Its going to change the working directory to $HOME, so when you import/export
+# into/from the ide $HOME is going to be the default directory, rather than
+# /usr/lib*/arduino/
+mkdir -p $PKG/usr/bin
+cat << EOF > $PKG/usr/bin/$PRGNAM
+#!/bin/sh
+cd \$HOME
+if [ \$(echo \$PATH | grep java | wc -l) -lt 1 ]; then
+ export PATH=\$PATH:/usr/lib$LIBDIRSUFFIX/java/bin:/usr/lib$LIBDIRSUFFIX/java/jre/bin:/usr/lib$LIBDIRSUFFIX/java/bin;
+fi;
+$SYSTEMFOLDER/arduino
+EOF
+chmod 0755 $PKG/usr/bin/$PRGNAM
+
+mkdir -p $PKG/$SYSTEMFOLDER
+cp -a ../$PRGNAM-$VERSION/* $PKG/$SYSTEMFOLDER/
install -D -m 644 $CWD/arduino.desktop $PKG/usr/share/applications/arduino.desktop
install -D -m 644 $CWD/arduino.png $PKG/usr/share/pixmaps/arduino.png